# coding: utf-8
'''
Created on 2.9.2014

@author: MW
'''

import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmcaddon,json,time,calendar
from HTMLParser import HTMLParser

addonID = 'plugin.video.sportdeutschland-tv'
addon = xbmcaddon.Addon(id=addonID)
translation = addon.getLocalizedString

MAIN_API_URL = 'http://sportdeutschland.tv/api/'

def CATEGORIES():
        
        #Live-Events
        count = 0
        url = MAIN_API_URL + 'assets/next_live'
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        req.add_header('Accept', 'application/vnd.vidibus.v2.html+json')		
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        data = json.loads(data)
        data = data['items']
        for item in data:
            if item.get('video'):
                count += 1
        addDir('Live (' + str(count) + ')','live',1,'')

        #Programm
        addDir('Programm','programm',3,'')

        #Kategorien
        url = MAIN_API_URL + 'sections?per_page=9999'
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        req.add_header('Accept', 'application/vnd.vidibus.v2.html+json')		
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        data = json.loads(data)
        data = data['items']
        for item in data:
            addDir(item.get('title', None).encode('utf-8'),
                   item.get('uuid', None).encode('utf-8'),
                   2,
                   '')

def VIDEOLINKS(url,name):
        url = MAIN_API_URL + 'sections/' + url + '/assets?per_page=200'
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        req.add_header('Accept', 'application/vnd.vidibus.v2.html+json')		
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        data = json.loads(data)		
        data = data['items']
        for item in data:
            if item.get('video'):
                title = video = image = plot = ''

                if item.get('date'):
                    struct_time = time.strptime(item.get('date'),"%Y-%m-%dT%H:%M:%SZ")
                    title = time.strftime("%d.%m.%Y", time.localtime(calendar.timegm(struct_time))) + ' - '				
                if item.get('title'):
                    title = title + item.get('title').encode('utf-8')
                if item.get('video'):
                    video = item.get('video', None).encode('utf-8').replace('.smil?', '.m3u8?')
                if item.get('image'):
                    image = item.get('image', None).encode('utf-8')
                if item.get('teaser'):
                    plot = item.get('teaser', None).encode('utf-8')		
                
                addLink(title,video,image,plot)

def LIVE(url):
        url = MAIN_API_URL + 'assets/next_live'
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        req.add_header('Accept', 'application/vnd.vidibus.v2.html+json')		
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        data = json.loads(data)		
        data = data['items']
        for item in data:
            if item.get('video'):
                title = video = image = plot = ''

                if item.get('date'):
                    struct_time = time.strptime(item.get('date'),"%Y-%m-%dT%H:%M:%SZ")
                    title = time.strftime("%a, %d.%m.%Y, %H:%M", time.localtime(calendar.timegm(struct_time))) + ' - '
                if item.get('title'):
                    title = title + item.get('title').encode('utf-8')
                if item.get('video'):
                    video = item.get('video', None).encode('utf-8').replace('.smil?', '.m3u8?')
                if item.get('image'):
                    image = item.get('image', None).encode('utf-8')
                if item.get('teaser'):
                    plot = item.get('teaser', None).encode('utf-8')		
                
                addLink(title,video,image,plot)


def PROGRAMM(url):
        url = MAIN_API_URL + 'assets/next_live'
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        req.add_header('Accept', 'application/vnd.vidibus.v2.html+json')		
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        data = json.loads(data)		
        data = data['items']
        for item in data:
            title = video = image = plot = ''

            if item.get('date'):
                struct_time = time.strptime(item.get('date'),"%Y-%m-%dT%H:%M:%SZ")
                title = time.strftime("%a, %d.%m.%Y, %H:%M", time.localtime(calendar.timegm(struct_time))) + ' - '
            if item.get('title'):
                title = title + item.get('title').encode('utf-8')
            if item.get('image'):
                image = item.get('image', None).encode('utf-8')
            if item.get('teaser'):
                plot = item.get('teaser', None).encode('utf-8')	            

            addLink(title,video,image,plot)

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

def addLink(name,url,iconimage,plot):
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "plot": plot } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
        return ok


def addDir(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok
              
params=get_params()
url=None
name=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

if mode==None or url==None or len(url)<1:
        CATEGORIES()
       
elif mode==1:
        LIVE(url)
        
elif mode==2:
        VIDEOLINKS(url,name)

elif mode==3:
        PROGRAMM(url)

xbmcplugin.endOfDirectory(int(sys.argv[1]))
